<template>
    <div class="container">
        <div class="loading" v-if="loading">
            <p id="loadd">LOADING...</p>
        </div>
        <div class="card llegirCodi">
            <div class="card-header">Lector codi QR</div>
            <div class="card-body" id="videoQ">
                <video muted playsinline id="qr-video"></video>
            </div>
        </div>
        <div class="card mostraDades">
            <div class="card-header">Dades del treballador/a</div>
            <div class="card-body">
                <div class="dada" id="primer">
                    <b>Nom del treballador/a: </b>
                    <span id="nomTreballador"></span>
                </div>
                <div class="dada">
                    <b>Data: </b>
                    <span id="dataFitxar"></span>
                </div>
                <div class="dada">
                    <b>Hora: </b>
                    <span id="horaFitxar">None</span>
                </div>
                <div class="dada" id="btn">
                    <button class="btn btn-a" id="btn-arrow" disabled type="submit" v-on:click="validarConceptes()">
                        <span class="glyphicon" id="icon"></span>
                    </button>
                </div>
            </div>
            <div class="card-header">Registre per usuari</div>
            <div class="card-body">
                <div class="dada">
                    <label>Id usuari</label><br>
                    <input type="text" id="idTreballador" /><br><br>
                    <label>Contrassenya</label><br>
                    <input type="password" id="passTreballador" />
                    <div class="error" id="fitxarUser">
                        <p>L'id o la contrasenya no coincideixen</p>
                    </div>
                </div>
                <div class="dada">
                    <button class="btn btn-primary" id="" type="submit" v-on:click="fitxarUser()">
                        <span class="glyphicon" id="icon">Fitxar</span>
                    </button>
                    <a href="loginFitxar">Fitxar responsable</a>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import QrScanner from '../qr-scanner.min.js';
export default {
    props: ["user", "ruta", "dataH"],
    mounted() {
        console.log("Component mounted.");
    },
    data: function() {
        return {
            dataR: null,
            dataE: null,
            horaR: null,
            codiF: null,
            codiT: null,
            dataA: null,
            limit: null,
            entrada: null,
            treballador: [],
            treballadorP: null,
            scanner: null,
            contrasenya: null,
            dates: [],
            clientCentre: null,
            loading: false

        }
    },
    methods: {
        fitxarUser(){
            this.loading = true;
            const idTreballador = document.getElementById('idTreballador');
            const passTreballador = document.getElementById('passTreballador');
            this.contrasenya = passTreballador.value;
            this.codiT = idTreballador.value;
            axios
            .get(this.ruta + '/api/treballadorByIdByPassword/' + this.codiT + '-' + this.contrasenya)
            .then(response => {
                this.treballadorP = response.data;
                if(this.treballadorP.id == this.codiT){
                    document.getElementById("fitxarUser").style.visibility = "hidden";
                    this.setResult('user');
                }else{
                    document.getElementById("fitxarUser").style.visibility = "visible";
                }
            });
        },
        fitxarQr(result){
            this.loading = true;
            this.scanner.stop();
            this.codiT = result;
            this.setResult('camera');
        },
        setResult($tipus) {
            const dataFitxar = document.getElementById('dataFitxar');
            const horaFitxar = document.getElementById('horaFitxar');
            axios
            .get(this.ruta + '/api/obtenirData')
            .then(response => {
                this.dates = response.data;
                this.horaR = this.dates[0];
                this.dataR = this.dates[1];
                this.dataE = this.dates[2];
                this.formatData();
                axios
                .get(this.ruta + '/api/treballadorById/' + this.codiT)
                .then(response => {
                    this.treballador = response.data;
                    nomTreballador.textContent = this.treballador.nom;
                    dataFitxar.textContent = this.dataR;
                    horaFitxar.textContent = this.horaR;
                    
                    var res = this.dataR.replace(/\//g, "-");
                    this.codiF = res+'-';
                    res = this.horaR.replace(/:/g, "-")
                    this.codiF += res;
                    axios
                    .get(this.ruta + '/api/entradaosortida/' + this.codiT)
                    .then(response => {
                        this.dataA = response.data;
                        this.limit = this.dataA.length;

                        var btn = document.getElementById("btn-arrow");
                        var spa = document.getElementById("icon");
                        if(this.limit == 0){
                            this.entrada = 0;
                            btn.classList.add("btn-success");
                            spa.classList.add("glyphicon-chevron-left");
                        }else{
                            this.entrada = this.dataA[this.limit - 1].entradasortida;
                            if(this.entrada == 0){
                                this.entrada = 1;
                                btn.classList.remove("btn-success");
                                btn.classList.add("btn-danger");
                                spa.classList.remove("glyphicon-chevron-left");
                                spa.classList.add("glyphicon-chevron-right");
                            }else{
                                this.entrada = 0;
                                btn.classList.remove("btn-danger");
                                btn.classList.add("btn-success");
                                spa.classList.remove("glyphicon-chevron-right")
                                spa.classList.add("glyphicon-chevron-left");
                            }
                        }

                        this.guardar($tipus);
                    }).finally(() => this.loading = false);
                });
            });
        },
        guardar($tipus){
            axios
            .get(this.ruta + '/api/obtenircentreclient/' + this.user)
            .then(response => {
                this.clientCentre = response.data;
                var $apiRuta = "";
                if($tipus == 'camera'){
                    $apiRuta = "/api/registrecamera";
                }else{
                    $apiRuta = "/api/registre";
                }
                axios
                .post(this.ruta + $apiRuta, {
                    treballador_id: this.codiT,
                    dataRegistre: this.dataE,
                    horaRegistre: this.horaR,
                    entradasortida: this.entrada,
                    client_id: this.clientCentre.client_id,
                    centre_id: this.clientCentre.centre_id
                })
                .then(response => {
                    this.scanner.start();
                });
            });        
        },
        formatData(){
            var dataRR = this.dataR.split("/");
            if(dataRR[0] < 10){
                dataRR[0] = "0" + dataRR[0];
            }
            if(dataRR[1] < 10){
                dataRR[1] = "0" + dataRR[1];
            }
            if(dataRR[2] < 10){
                dataRR[2] = "0" + dataRR[2];
            }
            this.dataR = dataRR[0] + "/" + dataRR[1] + "/" + dataRR[2];
            var dataEE = this.dataE.split("-");
            if(dataEE[1] < 10){
                dataEE[1] = "0" + dataEE[1];
            }
            if(dataEE[2] < 10){
                dataEE[2] = "0" + dataEE[2];
            }
            this.dataE = dataEE[0] + "-" + dataEE[1] + "-" + dataEE[2];
            var horaRR = this.horaR.split(":");
            if(horaRR[0] < 10){
                horaRR[0] = "0" + horaRR[0];
            }
            if(horaRR[1] < 10){
                horaRR[1] = "0" + horaRR[1];
            }
            if(horaRR[2] < 10){
                horaRR[2] = "0" + horaRR[2];
            }
            this.horaR = horaRR[0] + ":" + horaRR[1] + ":" + horaRR[2];
        }
    },
    mounted: function() {
        console.log("Component mounted.");
        QrScanner.WORKER_PATH = '/js/qr-scanner-worker.min.js';
        const video = document.getElementById('qr-video');
        const nomTreballador = document.getElementById('nomTreballador');
        
        this.scanner = new QrScanner(video, result => this.fitxarQr(result));
        this.scanner.start();
    }
}
</script>

